part of spark;

/// theme widget builder
typedef WidgetThemeBuilder = Widget Function(BuildContext context, SparkTheme theme);

enum Direction {
  /// horizontal direction
  horizontal,

  /// vertical direction
  vertical,
}

enum FormStrategy {
  /// form change strategy, if valitate error, back to old value
  limit,

  /// just tip error message
  tip
}

typedef TagGroupItemBuilder = Widget Function(BuildContext context, SparkTagGroupItem data);

typedef TagGroupItemIconBuilder = Positioned Function(BuildContext context, bool selected);

/// valitate function
typedef ValidateCallback = ValidateResult Function(dynamic value, VerifyType type);

/// updater
typedef ValueUpdater<T> = void Function(T value);

typedef Updater = void Function();

/// custom form widget builder
/// [value] is form item field value, that call on [value] change
/// [updater] value's updater, receive new [value] and update widget builder
typedef FormItemWrapperBuilder = Widget Function(BuildContext context, dynamic value, ValueUpdater updater);

/// spark select item options builder
/// [SparkSelect]
typedef ItemValueBuilder = Widget Function(BuildContext context, SparkOption value);

/// check string is empty
bool emptyOrNullString(String? value){
  return value == null || value == '';
}
